> ## Documentation Index
> Fetch the complete documentation index at: https://goldrush.dev/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# trace_replayTransaction on Arbitrum

> Call trace_replayTransaction on Arbitrum via GoldRush JSON-RPC. Replays a mined transaction and returns the requested Parity-style traces. Endpoint, parameters, return values, and code examples.

<Card title="0.015 credits per call" icon="coins" />

`trace_replayTransaction` on **Arbitrum**: Replays a mined transaction and returns the requested Parity-style traces.

<Note>
  `trace_replayTransaction` requires archive depth. See the [debug & trace matrix](/goldrush-json-rpc/debug-trace) for Arbitrum archive coverage.
</Note>

## Endpoint

```
https://rpc.goldrushdata.com/v1/arbitrum-mainnet
```

Authenticate with `Authorization: Bearer <GOLDRUSH_API_KEY>`. See [authentication](/goldrush-json-rpc/authentication).

## Parameters

| Name              | Type             | Required | Description                                                             | Example                                                                |
| ----------------- | ---------------- | -------- | ----------------------------------------------------------------------- | ---------------------------------------------------------------------- |
| `transactionHash` | `DATA, 32 bytes` | yes      | Transaction hash.                                                       | `"0x88df016429689c079f3b2f6ad39fa052532c56795b733da78a91ebe6a713944b"` |
| `traceTypes`      | `Array<String>`  | yes      | Trace types to include. One or more of `trace`, `vmTrace`, `stateDiff`. | `["trace", "stateDiff"]`                                               |

## Returns

`Object`: `{output, trace[], stateDiff?, vmTrace?}`

```json theme={null}
{"output":"0x","trace":[{"action":{"from":"0x...","to":"0x..."},"result":{"gasUsed":"0x5208"},"type":"call"}],"stateDiff":{}}
```

## Examples

<CodeGroup>
  ```bash curl theme={null}
  curl https://rpc.goldrushdata.com/v1/arbitrum-mainnet \
    -H "Authorization: Bearer $GOLDRUSH_API_KEY" \
    -H "Content-Type: application/json" \
    -d '{
      "jsonrpc": "2.0",
      "id": 1,
      "method": "trace_replayTransaction",
      "params": ["0x88df016429689c079f3b2f6ad39fa052532c56795b733da78a91ebe6a713944b", ["trace", "stateDiff"]]
    }'
  ```

  ```typescript ethers v6 theme={null}
  import { ethers } from "ethers";

  const url = "https://rpc.goldrushdata.com/v1/arbitrum-mainnet";
  const fetchReq = new ethers.FetchRequest(url);
  fetchReq.setHeader("Authorization", `Bearer ${process.env.GOLDRUSH_API_KEY}`);

  const provider = new ethers.JsonRpcProvider(fetchReq);
  const result = await provider.send("trace_replayTransaction", ["0x88df016429689c079f3b2f6ad39fa052532c56795b733da78a91ebe6a713944b", ["trace", "stateDiff"]]);
  console.log(result);
  ```

  ```typescript viem theme={null}
  import { createPublicClient, http } from "viem";

  const client = createPublicClient({
    transport: http("https://rpc.goldrushdata.com/v1/arbitrum-mainnet", {
      fetchOptions: {
        headers: {
          Authorization: `Bearer ${process.env.GOLDRUSH_API_KEY}`,
        },
      },
    }),
  });

  const result = await client.request({
    method: "trace_replayTransaction",
    params: ["0x88df016429689c079f3b2f6ad39fa052532c56795b733da78a91ebe6a713944b", ["trace", "stateDiff"]],
  });
  console.log(result);
  ```

  ```javascript web3.js theme={null}
  import { Web3 } from "web3";

  const provider = new Web3.providers.HttpProvider(
    "https://rpc.goldrushdata.com/v1/arbitrum-mainnet",
    {
      headers: [
        { name: "Authorization", value: `Bearer ${process.env.GOLDRUSH_API_KEY}` },
      ],
    }
  );
  const web3 = new Web3(provider);

  const result = await web3.currentProvider.request({
    method: "trace_replayTransaction",
    params: ["0x88df016429689c079f3b2f6ad39fa052532c56795b733da78a91ebe6a713944b", ["trace", "stateDiff"]],
  });
  console.log(result);
  ```

  ```python web3.py theme={null}
  from os import environ
  from web3 import Web3

  w3 = Web3(Web3.HTTPProvider(
      "https://rpc.goldrushdata.com/v1/arbitrum-mainnet",
      request_kwargs={
          "headers": {
              "Authorization": f"Bearer {environ['GOLDRUSH_API_KEY']}",
          },
      },
  ))
  result = w3.manager.request_blocking("trace_replayTransaction", ["0x88df016429689c079f3b2f6ad39fa052532c56795b733da78a91ebe6a713944b", ["trace", "stateDiff"]])
  print(result)
  ```
</CodeGroup>

## Errors

Standard JSON-RPC errors: `-32600` invalid request, `-32601` method not found, `-32602` invalid params.

## Related Debug and trace methods on Arbitrum

* [`debug_traceTransaction` on Arbitrum](/api-reference/json-rpc/arbitrum/debug-tracetransaction)
* [`debug_traceCall` on Arbitrum](/api-reference/json-rpc/arbitrum/debug-tracecall)
* [`debug_traceBlockByHash` on Arbitrum](/api-reference/json-rpc/arbitrum/debug-traceblockbyhash)
* [`debug_traceBlockByNumber` on Arbitrum](/api-reference/json-rpc/arbitrum/debug-traceblockbynumber)
* [`trace_transaction` on Arbitrum](/api-reference/json-rpc/arbitrum/trace-transaction)

## Also available on

* [`trace_replayTransaction` on Ethereum](/api-reference/json-rpc/ethereum/trace-replaytransaction)
* [`trace_replayTransaction` on Polygon](/api-reference/json-rpc/polygon/trace-replaytransaction)
* [`trace_replayTransaction` on BNB Smart Chain (BSC)](/api-reference/json-rpc/bsc/trace-replaytransaction)
* [`trace_replayTransaction` on Base](/api-reference/json-rpc/base/trace-replaytransaction)
* [`trace_replayTransaction` on HyperEVM](/api-reference/json-rpc/hyperevm/trace-replaytransaction)
